Index: pjproject/trunk/pjsip/build/pjsip.dsw
===================================================================
--- pjproject/trunk/pjsip/build/pjsip.dsw	(revision 123)
+++ pjproject/trunk/pjsip/build/pjsip.dsw	(revision 127)
@@ -5,4 +5,16 @@
 
 Project: "pjlib"=..\..\pjlib\build\pjlib.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib++"="..\..\pjlib\build\pjlib++.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -29,4 +41,16 @@
 
 Project: "pjmedia"=..\..\pjmedia\build\pjmedia.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjsip++"=".\pjsip++.dsp" - Package Owner=<4>
 
 Package=<5>
Index: pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 123)
+++ pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 127)
@@ -86,4 +86,71 @@
 
 # PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Group "Base (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_errno.c
+# End Source File
+# End Group
+# Begin Group "Messaging and Parsing (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_msg.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_parser.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_tel_uri.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_uri.c
+# End Source File
+# End Group
+# Begin Group "Core (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_endpoint.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util_proxy.c
+# End Source File
+# End Group
+# Begin Group "Transport Layer (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_resolve.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport_loop.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_transport_udp.c
+# End Source File
+# End Group
+# Begin Group "Authentication (.c)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
@@ -102,55 +169,11 @@
 SOURCE=..\src\pjsip\sip_auth_server.c
 # End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_endpoint.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_errno.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_msg.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_parser.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_resolve.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_tel_uri.c
-# End Source File
+# End Group
+# Begin Group "Transaction Layer (.c)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
 SOURCE=..\src\pjsip\sip_transaction.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport_loop.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_transport_udp.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_uri.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_util.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsip\sip_util_proxy.c
 # End Source File
 # Begin Source File
@@ -160,11 +183,43 @@
 # End Source File
 # End Group
+# Begin Group "UA Layer (.c)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_dialog.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_ua_layer.c
+# End Source File
+# End Group
+# End Group
 # Begin Group "Header Files"
 
 # PROP Default_Filter "h;hpp;hxx;hm;inl"
-# Begin Source File
-
-SOURCE=..\include\pjsip_core.h
-# End Source File
+# Begin Group "Base Types (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_config.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_errno.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_private.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_types.h
+# End Source File
+# End Group
+# Begin Group "Messaging and Parsing (.h)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
@@ -173,4 +228,64 @@
 # Begin Source File
 
+SOURCE=..\include\pjsip\sip_msg.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_parser.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_tel_uri.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_uri.h
+# End Source File
+# End Group
+# Begin Group "Core (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_endpoint.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_event.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_module.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_util.h
+# End Source File
+# End Group
+# Begin Group "Transport Layer (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_resolve.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport_loop.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_transport_udp.h
+# End Source File
+# End Group
+# Begin Group "Authentication (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
 SOURCE=..\include\pjsip\sip_auth.h
 # End Source File
@@ -183,71 +298,28 @@
 SOURCE=..\include\pjsip\sip_auth_parser.h
 # End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_config.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_endpoint.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_errno.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_event.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_module.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_msg.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_parser.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_private.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_resolve.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_tel_uri.h
-# End Source File
+# End Group
+# Begin Group "Transaction Layer (.h)"
+
+# PROP Default_Filter ""
 # Begin Source File
 
 SOURCE=..\include\pjsip\sip_transaction.h
 # End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport_loop.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_transport_udp.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_types.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_uri.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\pjsip\sip_util.h
+# End Group
+# Begin Group "UA Layer (.h)"
+
+# PROP Default_Filter ""
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_dialog.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_ua_layer.h
+# End Source File
+# End Group
+# Begin Source File
+
+SOURCE=..\include\pjsip.h
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/build/pjsip_ua.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 123)
+++ pjproject/trunk/pjsip/build/pjsip_ua.dsp	(revision 127)
@@ -88,17 +88,14 @@
 # Begin Source File
 
-SOURCE="..\src\pjsip-ua\sip_dialog.c"
-# End Source File
-# Begin Source File
+SOURCE="..\src\pjsip-ua\sip_reg.c"
 
-SOURCE="..\src\pjsip-ua\sip_reg.c"
-# End Source File
-# Begin Source File
+!IF  "$(CFG)" == "pjsip_ua - Win32 Release"
 
-SOURCE="..\src\pjsip-ua\sip_ua.c"
-# End Source File
-# Begin Source File
+!ELSEIF  "$(CFG)" == "pjsip_ua - Win32 Debug"
 
-SOURCE="..\src\pjsip-ua\sip_ua_private.h"
+# PROP Exclude_From_Build 1
+
+!ENDIF 
+
 # End Source File
 # End Group
@@ -108,13 +105,5 @@
 # Begin Source File
 
-SOURCE="..\include\pjsip-ua\sip_dialog.h"
-# End Source File
-# Begin Source File
-
 SOURCE="..\include\pjsip-ua\sip_regc.h"
-# End Source File
-# Begin Source File
-
-SOURCE="..\include\pjsip-ua\sip_ua.h"
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 123)
+++ pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 127)
@@ -90,4 +90,8 @@
 # Begin Source File
 
+SOURCE="..\src\test-pjsip\dlg_core_test.c"
+# End Source File
+# Begin Source File
+
 SOURCE="..\src\test-pjsip\main.c"
 # End Source File
